import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Base, Type, Point } from "igniteui-react-core";
import { Series } from "./Series";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { LabelCollisionPlacementPositions } from "igniteui-react-core";
import { HighlightedValueLabelMode } from "igniteui-react-core";
import { AutoCalloutVisibilityMode } from "./AutoCalloutVisibilityMode";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CalloutCollisionMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { Size } from "igniteui-react-core";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-react-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    protected bj(): Series;
    protected get_eo(): boolean;
    constructor();
    private adu;
    private ad3;
    private adv;
    protected pb(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gf(a: boolean): boolean;
    aa2: boolean;
    private afv;
    abq: number;
    abo: number;
    abr: number;
    abp: number;
    private aau;
    private aft;
    wr(): Size;
    private abf;
    private ad9;
    private aea;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    ac9: string;
    kq(a: any, b: string): any;
    md(a: string): string;
    get aan(): IFastItemColumn$1<any>;
    set aan(a: IFastItemColumn$1<any>);
    private aai;
    adp: string;
    get aao(): IFastItemColumn$1<any>;
    set aao(a: IFastItemColumn$1<any>);
    private aaj;
    ads: string;
    get aap(): IFastItemColumn$1<any>;
    set aap(a: IFastItemColumn$1<any>);
    private aak;
    ac3: string;
    get aam(): IFastItemColumn$1<any>;
    set aam(a: IFastItemColumn$1<any>);
    private aah;
    aa4: boolean;
    ac6: string;
    zw: any[];
    acv: string;
    get aal(): IFastItemColumn$1<any>;
    set aal(a: IFastItemColumn$1<any>);
    private aag;
    private abg;
    private abj;
    private adx;
    protected cs(): SeriesView;
    qz(a: SeriesView): void;
    protected z6: CalloutLayerView;
    private abk;
    adc: string;
    aad: Series;
    acs: string;
    private z7;
    get z8(): CalloutPlacementPositionsCollection;
    set z8(a: CalloutPlacementPositionsCollection);
    zv: LabelCollisionPlacementPositions[];
    aa3: boolean;
    aa9: boolean;
    abc: boolean;
    gu(a: Series): boolean;
    aa8: boolean;
    aba: boolean;
    abb: boolean;
    abd: boolean;
    aac: HighlightedValueLabelMode;
    get z1(): AutoCalloutVisibilityMode;
    set z1(a: AutoCalloutVisibilityMode);
    get z0(): AutoCalloutVisibilityMode;
    set z0(a: AutoCalloutVisibilityMode);
    static readonly aew: DependencyProperty;
    abn: number;
    aa6: boolean;
    aa5: boolean;
    ab0: number;
    afp: Brush;
    afn: Brush;
    afl: Brush;
    afk: Brush;
    aa7: boolean;
    ab1: number;
    afo: Brush;
    afm: Brush;
    get afu(): Thickness;
    abt: number;
    abv: number;
    abu: number;
    abs: number;
    z3: CalloutCollisionMode;
    abw: number;
    abx: number;
    adf: string;
    private aae;
    get aaf(): FontInfo;
    protected yn(a: Series, b: boolean): void;
    protected yp(a: Frame, b: SeriesView): void;
    private abh;
    private abe;
    private aaq;
    private afr;
    protected sp(a: Rect, b: Rect): void;
    protected so(a: Rect, b: Rect): void;
    private aay;
    private abz;
    private afq;
    get afs(): Rect;
    set afs(a: Rect);
    private aaw;
    private ad4;
    private adh;
    private adz;
    private aar;
    private ab2;
    private ab3;
    private aas;
    private adw;
    private aat;
    private aby;
    private abl;
    private ab4;
    protected xg(a: Series): boolean;
    qn(): void;
    private aax;
    ad2(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private abi;
    private ad5;
    private aa0;
    private aa1;
    private abm;
    private aaz;
    protected b2(): SeriesHitTestMode;
    a2(a: Point, b: boolean): DataContext;
    gw(a: Point, b: boolean): boolean;
    protected ad8(a: CalloutLayerFrame, b: boolean): void;
    protected ys(a: Frame, b: SeriesView): void;
    protected ga(): boolean;
    private zy;
    protected q7(a: any, b: string, c: any, d: any): void;
    private z2;
    private zx;
    private ad7;
    private aav;
    private zz;
    private ad0;
    ax(a: AxisRange, b: NumericAxisBase, c: Rect): AxisRange;
    private ad6;
    private ady;
    private ad1;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected b7: CalloutLayer;
    private cc;
    au(): void;
    private b9;
    private cf;
    private ch;
    private cg;
    cb: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    cq(a: Brush): Brush;
    protected a8(a: RenderingContext, b: boolean): void;
    protected ca(): FontInfo;
    an(a: any): void;
    private cd;
    cs(a: TextBlock): Size;
    private ce;
    private b8;
    cr(a: any, b: Thickness): Size;
    cj(a: CalloutView, b: number, c: number): void;
    ck(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    cl(a: Series, b: Brush): Brush;
    co(): Brush;
    cm(): Brush;
    cp(a: Series, b: Brush): Brush;
    cn(a: Series, b: Brush): Brush;
    ci(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    y: Visibility;
    j(a: RenderingContext): void;
    private l;
    private t;
    private q;
    private s;
    get r(): Point;
    set r(a: Point);
    get p(): Brush;
    set p(a: Brush);
    get o(): Brush;
    set o(a: Brush);
    get n(): Brush;
    set n(a: Brush);
    get m(): Brush;
    set m(a: Brush);
    get e(): number;
    set e(a: number);
    private w;
    private v;
    get x(): Thickness;
    set x(a: Thickness);
    private c;
    get d(): number;
    set d(a: number);
    get h(): any;
    set h(a: any);
    f: number;
    g: number;
    u(): Size;
    private b;
    k(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    i(a: CalloutLayer, b: FontInfo, c: any): void;
}
